## libretro-snes9x 1.53+git20160522

=== Makefile ===
DEBUG = 0
HAVE_EXCEPTIONS = 0

ifeq ($(platform),)
	platform = unix
	ifeq ($(shell uname -a),)
		platform = win
	else ifneq ($(findstring Darwin,$(shell uname -a)),)
		platform = osx
		arch = intel
		ifeq ($(shell uname -p),powerpc)
			arch = ppc
		endif
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
		platform = win
	else ifneq ($(findstring win,$(shell uname -a)),)
		platform = win
	endif
endif

CXX			?= g++
CC			?= gcc
TARGET_NAME	= snes9x
LIBM		= -lm

# Unix
ifeq ($(platform), unix)
	TARGET := $(TARGET_NAME)_libretro.so
	fpic := -fPIC
	SHARED := -shared -Wl,--version-script=link.T
	ifneq ($(findstring Haiku,$(shell uname -a)),)
		LIBM :=
	endif

# OS X
else ifeq ($(platform), osx)
	TARGET := $(TARGET_NAME)_libretro.dylib
	fpic := -fPIC
	SHARED := -dynamiclib

	arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif

	ifeq ($(arch),ppc)
		CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
	endif
	OSXVER = `sw_vers -productVersion | cut -d. -f 2`
	OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
	fpic += -mmacosx-version-min=10.1

# iOS
else ifneq (,$(findstring ios,$(platform)))
	TARGET := $(TARGET_NAME)_libretro_ios.dylib
	fpic := -fPIC
	SHARED := -dynamiclib

	ifeq ($(IOSSDK),)
		IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
	endif

	CC = clang -arch armv7 -isysroot $(IOSSDK)
	CXX = clang++ -arch armv7 -isysroot $(IOSSDK)
	CXXFLAGS += -DIOS
	CXXFLAGS += -DARM
ifeq ($(platform),ios9)
	CC       += -miphoneos-version-min=8.0
	CXX      += -miphoneos-version-min=8.0
	CFLAGS   += -miphoneos-version-min=8.0
	CXXFLAGS += -miphoneos-version-min=8.0
else
	CC       += -miphoneos-version-min=5.0
	CXX      += -miphoneos-version-min=5.0
	CFLAGS   += -miphoneos-version-min=5.0
	CXXFLAGS += -miphoneos-version-min=5.0
endif
else ifeq ($(platform), theos_ios)
DEPLOYMENT_IOSVERSION = 5.0
TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
ARCHS = armv7 armv7s
TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
THEOS_BUILD_DIR := objs
include $(THEOS)/makefiles/common.mk

LIBRARY_NAME = $(TARGET_NAME)_libretro_ios

# QNX
else ifeq ($(platform), qnx)
	TARGET := $(TARGET_NAME)_libretro_qnx.so
	fpic := -fPIC
	SHARED := -shared -Wl,--version-script=link.T
	CC = qcc -Vgcc_notarmv7le
	CXX = QCC -Vgcc_notarmv7le
	AR = QCC -Vgcc_ntoarmv7le
	CXXFLAGS += -D__BLACKBERRY_QNX__
	CXXFLAGS += -DARM
	HAVE_EXCEPTIONS = 1

# Vita
else ifeq ($(platform), vita)
	TARGET := $(TARGET_NAME)_libretro_vita.so
	fpic := -fPIC
	CC = arm-vita-eabi-gcc$(EXE_EXT)
	CXX = arm-vita-eabi-g++$(EXE_EXT)
	AR = arm-vita-eabi-ar$(EXE_EXT)
	CXXFLAGS += -DVITA
	HAVE_EXCEPTIONS = 1

# PS3
else ifeq ($(platform), ps3)
	TARGET := $(TARGET_NAME)_libretro_ps3.a
	CC = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-gcc.exe
	CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
	AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe
	CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
	STATIC_LINKING = 1

# sncps3
else ifeq ($(platform), sncps3)
	TARGET := $(TARGET_NAME)_libretro_ps3.a
	CC = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
	CXX = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
	AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe
	CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
	STATIC_LINKING = 1

# Lightweight PS3 Homebrew SDK
else ifeq ($(platform), psl1ght)
	TARGET := $(TARGET_NAME)_libretro_psl1ght.a
	CC = $(PS3DEV)/ppu/bin/ppu-gcc$(EXE_EXT)
	CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
	AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
	CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
	STATIC_LINKING = 1

# Xbox 360
else ifeq ($(platform), xenon)
	TARGET := $(TARGET_NAME)_libretro_xenon360.a
	CC = xenon-gcc$(EXE_EXT)
	CXX = xenon-g++$(EXE_EXT)
	AR = xenon-ar$(EXE_EXT)
	CXXFLAGS += -D__LIBXENON__ -m32 -D__ppc__
	STATIC_LINKING = 1

# Nintendo Wii
else ifeq ($(platform), wii)
	TARGET := $(TARGET_NAME)_libretro_wii.a
	CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
	CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
	AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
	CXXFLAGS += -DGEKKO -mrvl -mcpu=750 -meabi -mhard-float -DBLARGG_BIG_ENDIAN=1 -D__ppc__
	STATIC_LINKING = 1

# ARM
else ifneq (,$(findstring armv,$(platform)))
	TARGET := $(TARGET_NAME)_libretro.so
	SHARED := -shared -Wl,--no-undefined
	fpic := -fPIC
	CC ?= gcc
	CXX ?= g++
	ifneq (,$(findstring cortexa8,$(platform)))
		CXXFLAGS += -marm -mcpu=cortex-a8
	else ifneq (,$(findstring cortexa9,$(platform)))
		CXXFLAGS += -marm -mcpu=cortex-a9
	endif
	CXXFLAGS += -marm
	ifneq (,$(findstring neon,$(platform)))
		CXXFLAGS += -mfpu=neon
		HAVE_NEON = 1
	endif
	ifneq (,$(findstring softfloat,$(platform)))
		CXXFLAGS += -mfloat-abi=softfp
	else ifneq (,$(findstring hardfloat,$(platform)))
		CXXFLAGS += -mfloat-abi=hard
	endif
	CXXFLAGS += -DARM

# Windows
else
	TARGET := $(TARGET_NAME)_libretro.dll
	CC = gcc
	CXX = g++
	SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T
	CXXFLAGS += -D__WIN32__ -D__WIN32_LIBSNES__

endif

CORE_DIR := ..

ifeq ($(DEBUG), 1)
   CXXFLAGS += -O0 -g
   CFLAGS += -O0 -g
else
   CXXFLAGS += -O3 -DNDEBUG
   CFLAGS += -O3 -DNDEBUG
endif

include Makefile.common

OBJECTS := $(SOURCES_CXX:.cpp=.o) $(SOURCES_C:.c=.o)

ifeq ($(platform), sncps3)
	WARNINGS_DEFINES =
	CODE_DEFINES =
else
	WARNINGS_DEFINES = -Wall -W -Wno-unused-parameter
	CODE_DEFINES = -fomit-frame-pointer
endif

ifneq ($(HAVE_EXCEPTIONS), 1)
CXXFLAGS += -fno-exceptions
endif

CXXFLAGS	+= $(CODE_DEFINES) -fno-rtti -pedantic $(WARNINGS_DEFINES) $(fpic)
CXXFLAGS	+= -DHAVE_STRINGS_H -DHAVE_STDINT_H -DRIGHTSHIFT_IS_SAR -D__LIBRETRO__
CFLAGS		= $(CXXFLAGS)

ifeq ($(platform), theos_ios)
COMMON_FLAGS := -DIOS -DARM $(COMMON_DEFINES) $(INCFLAGS) -I$(THEOS_INCLUDE_PATH) -Wno-error
$(LIBRARY_NAME)_CFLAGS += $(CFLAGS) $(COMMON_FLAGS)
$(LIBRARY_NAME)_CXXFLAGS += $(CXXFLAGS) $(COMMON_FLAGS)
${LIBRARY_NAME}_FILES = $(SOURCES_CXX) $(SOURCES_C)
include $(THEOS_MAKE_PATH)/library.mk
else
all: $(TARGET)

$(TARGET): $(OBJECTS)
ifeq ($(STATIC_LINKING), 1)
	$(AR) rcs $@ $(OBJECTS)
else
	$(CXX) $(fpic) $(SHARED) $(INCFLAGS) -o $@ $(OBJECTS) $(LIBM)
endif

%.o: %.cpp 
	$(CXX) $(INCFLAGS) $(CXXFLAGS) -c -o $@ $<

%.o: %.c
	$(CC) $(INCFLAGS) $(CFLAGS) -c -o $@ $<

clean:
	rm -f $(OBJECTS) $(TARGET)
endif

=== debian/changelog ===
libretro-snes9x (1.53+git20160522-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:46:43 +0100

libretro-snes9x (1.53+git20160522-1) unstable; urgency=low

  * Initial release (Closes: #820643).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 12 Jun 2016 20:56:00 -0300

=== debian/control ===
Source: libretro-snes9x
Section: non-free/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.8
Homepage: http://www.snes9x.com

Package: libretro-snes9x
Architecture: any
Multi-Arch: same
Depends: retroarch | libretro-frontend, ${misc:Depends}, ${shlibs:Depends}
Description: Libretro wrapper for Snes9x
 This wrapper makes Snes9x API compatible with libretro, thus allowing its use
 with libretro frontends, such as RetroArch.
 .
 Snes9x is a portable, freeware Super Nintendo Entertainment System (SNES)
 emulator written in C++. It basically allows you to play most games designed
 for the SNES and Super Famicom Nintendo game systems on your PC or Workstation.
 .
 Super Nintendo Entertainment System, SNES and Super Famicom are trademarks of
 Nintendo of America Inc. Snes9x is not affiliated with or endorsed by any of
 the companies mentioned.

## libretro-snes9x 1.59.2

=== libretro/Makefile ===
DEBUG = 0
HAVE_EXCEPTIONS = 0
HAVE_STRINGS_H = 1

LTO ?= -flto
SPACE :=
SPACE := $(SPACE) $(SPACE)
BACKSLASH :=
BACKSLASH := \$(BACKSLASH)
filter_out1 = $(filter-out $(firstword $1),$1)
filter_out2 = $(call filter_out1,$(call filter_out1,$1))

ifeq ($(platform),)
   platform = unix
   ifeq ($(shell uname -s),)
      platform = win
   else ifneq ($(findstring MINGW,$(shell uname -s)),)
      platform = win
   else ifneq ($(findstring Darwin,$(shell uname -s)),)
      platform = osx
      arch = intel
      ifeq ($(shell uname -p),powerpc)
         arch = ppc
      endif
   else ifneq ($(findstring win,$(shell uname -s)),)
      platform = win
   endif
else ifneq (,$(findstring armv,$(platform)))
   ifeq (,$(findstring classic_,$(platform)))
      override platform += unix
   endif
else ifneq (,$(findstring rpi,$(platform)))
   override platform += unix
endif

TARGET_NAME	= snes9x

LIBS     =

ifeq (,$(findstring msvc,$(platform)))
LIBS		+= -lm
endif

GIT_VERSION := " $(shell git rev-parse --short HEAD || echo unknown)"
ifneq ($(GIT_VERSION)," unknown")
   CXXFLAGS += -DGIT_VERSION=\"$(GIT_VERSION)\"
endif

# Unix
ifneq (,$(findstring unix,$(platform)))
   CFLAGS += $(LTO)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   ifneq ($(findstring SunOS,$(shell uname -a)),)
   CC = gcc
   SHARED := -shared -z defs
   else
   SHARED := -shared -Wl,--version-script=link.T -Wl,-z,defs
   endif
   ifneq ($(findstring Haiku,$(shell uname -a)),)
      LIBS :=
   endif

   # ARM
   ifneq (,$(findstring armv,$(platform)))
      CXXFLAGS += -DARM
   # Raspberry Pi
   else ifneq (,$(findstring rpi,$(platform)))
      CXXFLAGS += -DARM
   endif

# OS X
else ifeq ($(platform), osx)
   CFLAGS += $(LTO)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   arch = intel
   ifeq ($(shell uname -p),powerpc)
      arch = ppc
   endif
   ifeq ($(arch),ppc)
      CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   endif
   OSXVER = $(shell sw_vers -productVersion | cut -d. -f 2)
   OSX_GT_MOJAVE = $(shell (( $(OSXVER) >= 14)) && echo "YES")
   ifneq ($(OSX_GT_MOJAVE),YES)
	#this breaks compiling on Mac OS Mojave
      fpic += -mmacosx-version-min=10.1
   endif

# Nintendo Switch (libnx)
else ifeq ($(platform), libnx)
   include $(DEVKITPRO)/libnx/switch_rules
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   DEFINES := -DSWITCH=1 -D__SWITCH__ -DARM
   CFLAGS := $(DEFINES) -fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -specs=$(LIBNX)/switch.specs
   CFLAGS += -march=armv8-a -mtune=cortex-a57 -mtp=soft -mcpu=cortex-a57+crc+fp+simd -ffast-math
   CXXFLAGS := $(ASFLAGS) $(CFLAGS)
   STATIC_LINKING = 1

# Classic Platforms ####################
# Platform affix = classic_<ISA>_<µARCH>
# Help at https://modmyclassic.com/comp

# (armv7 a7, hard point, neon based) ### 
# NESC, SNESC, C64 mini 
else ifeq ($(platform), classic_armv7_a7)
	TARGET := $(TARGET_NAME)_libretro.so
	fpic := -fPIC
	SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
	CXXFLAGS += -Ofast \
	-flto=4 -fwhole-program -fuse-linker-plugin \
	-fdata-sections -ffunction-sections -Wl,--gc-sections \
	-fno-stack-protector -fno-ident -fomit-frame-pointer \
	-falign-functions=1 -falign-jumps=1 -falign-loops=1 \
	-fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
	-fmerge-all-constants -fno-math-errno \
	-marm -mtune=cortex-a7 -mfpu=neon-vfpv4 -mfloat-abi=hard
	CFLAGS += $(CXXFLAGS)
	HAVE_NEON = 1
	ARCH = arm
	BUILTIN_GPU = neon
	USE_DYNAREC = 1
	ifeq ($(shell echo `$(CC) -dumpversion` "< 4.9" | bc -l), 1)
	  CFLAGS += -march=armv7-a
	else
	  CFLAGS += -march=armv7ve
	  # If gcc is 5.0 or later
	  ifeq ($(shell echo `$(CC) -dumpversion` ">= 5" | bc -l), 1)
	    LDFLAGS += -static-libgcc -static-libstdc++
	  endif
	endif
#######################################
   
# iOS
else ifneq (,$(findstring ios,$(platform)))
   CFLAGS += $(LTO)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   ifeq ($(IOSSDK),)
      IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
   endif
   ifeq ($(platform),ios-arm64)
		CC = clang -arch arm64 -isysroot $(IOSSDK)
		CXX = clang++ -arch arm64 -isysroot $(IOSSDK)
   else
		CC = clang -arch armv7 -isysroot $(IOSSDK)
		CXX = clang++ -arch armv7 -isysroot $(IOSSDK)
   endif
   CXXFLAGS += -DIOS
   CXXFLAGS += -DARM
   ifeq ($(platform),$(filter $(platform),ios9 ios-arm64))
      CC       += -miphoneos-version-min=8.0
      CXX      += -miphoneos-version-min=8.0
      CFLAGS   += -miphoneos-version-min=8.0
      CXXFLAGS += -miphoneos-version-min=8.0
   else
      CC       += -miphoneos-version-min=5.0
      CXX      += -miphoneos-version-min=5.0
      CFLAGS   += -miphoneos-version-min=5.0
      CXXFLAGS += -miphoneos-version-min=5.0
   endif

# Theos
else ifeq ($(platform), theos_ios)
   CFLAGS += $(LTO)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   DEPLOYMENT_IOSVERSION = 5.0
   TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
   ARCHS = armv7 armv7s
   TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
   THEOS_BUILD_DIR := objs
   include $(THEOS)/makefiles/common.mk
   LIBRARY_NAME = $(TARGET_NAME)_libretro_ios

# QNX
else ifeq ($(platform), qnx)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T
   CC = qcc -Vgcc_notarmv7le
   CXX = QCC -Vgcc_notarmv7le
   AR = QCC -Vgcc_ntoarmv7le
   CXXFLAGS += -D__BLACKBERRY_QNX__
   CXXFLAGS += -DARM
   HAVE_EXCEPTIONS = 1

# Vita
else ifeq ($(platform), vita)
   CFLAGS += $(LTO)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   CC = arm-vita-eabi-gcc$(EXE_EXT)
   CXX = arm-vita-eabi-g++$(EXE_EXT)
   AR = arm-vita-eabi-ar$(EXE_EXT)
   CXXFLAGS += -DVITA
   HAVE_EXCEPTIONS = 1

# PS3
else ifneq (,$(filter $(platform), ps3 sncps3 psl1ght))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   STATIC_LINKING = 1
   HAVE_STRINGS_H = 0

   # sncps3
   ifneq (,$(findstring sncps3,$(platform)))
      TARGET := $(TARGET_NAME)_libretro_ps3.a
      CC = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
      CXX = $(CC)
      AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe

   # PS3
   else ifneq (,$(findstring ps3,$(platform)))
      CC = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-gcc.exe
      CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
      AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe

   # Lightweight PS3 Homebrew SDK
   else ifneq (,$(findstring psl1ght,$(platform)))
      CC = $(PS3DEV)/ppu/bin/ppu-gcc$(EXE_EXT)
      CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
      AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
   endif

# Xbox 360
else ifeq ($(platform), xenon)
   CFLAGS += $(LTO)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro_xenon360.a
   CC = xenon-gcc$(EXE_EXT)
   CXX = xenon-g++$(EXE_EXT)
   AR = xenon-ar$(EXE_EXT)
   CXXFLAGS += -D__LIBXENON__ -m32 -D__ppc__
   STATIC_LINKING = 1

# Nintendo Game Cube / Wii / WiiU
else ifneq (,$(filter $(platform), ngc wii wiiu))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   CXXFLAGS += -mcpu=750 -meabi -mhard-float -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   STATIC_LINKING = 1

   # Nintendo WiiU
   ifneq (,$(findstring wiiu,$(platform)))
      CXXFLAGS += -mwup

   # Nintendo Wii
   else ifneq (,$(findstring wii,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl

   # Nintendo Game Cube
   else ifneq (,$(findstring ngc,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl
   endif

# Emscripten
else ifeq ($(platform), emscripten)
   TARGET := $(TARGET_NAME)_libretro_$(platform).bc
   STATIC_LINKING = 1

# Genode
else ifeq ($(platform), genode)
   TARGET  := $(TARGET_NAME)_libretro.lib.so
   PKG_CONFIG := genode-lib genode-stdcxx
   CXXFLAGS += -D__GENODE__
   CXXFLAGS += $(shell pkg-config --cflags $(PKG_CONFIG))

   LDFLAGS += -shared --version-script=link.T
   LDFLAGS += $(shell pkg-config --libs $(PKG_CONFIG))

   CC  = $(shell pkg-config genode-base --variable=cc)
   CXX = $(shell pkg-config genode-base --variable=cxx)
   LD  = $(shell pkg-config genode-base --variable=ld)
   AR  = $(shell pkg-config genode-base --variable=ar) -rcs
   LIBS =

# Windows MSVC 2003 Xbox 1
else ifeq ($(platform), xbox1_msvc2003)
CFLAGS += -D__WIN32__
CXXFLAGS += -D__WIN32__
TARGET := $(TARGET_NAME)_libretro_xdk1.lib
MSVCBINDIRPREFIX = $(XDK)/xbox/bin/vc71
CC  = "$(MSVCBINDIRPREFIX)/CL.exe"
CXX  = "$(MSVCBINDIRPREFIX)/CL.exe"
LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

export INCLUDE := $(XDK)/xbox/include
export LIB := $(XDK)/xbox/lib
PSS_STYLE :=2
CFLAGS   += -D_XBOX -D_XBOX1
CXXFLAGS += -D_XBOX -D_XBOX1
STATIC_LINKING=1
HAS_GCC := 0
# Windows MSVC 2010 Xbox 360
else ifeq ($(platform), xbox360_msvc2010)
CFLAGS += -D__WIN32__
CXXFLAGS += -D__WIN32__
TARGET := $(TARGET_NAME)_libretro_xdk360.lib
MSVCBINDIRPREFIX = $(XEDK)/bin/win32
CC  = "$(MSVCBINDIRPREFIX)/cl.exe"
CXX  = "$(MSVCBINDIRPREFIX)/cl.exe"
LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

export INCLUDE := $(XEDK)/include/xbox
export LIB := $(XEDK)/lib/xbox
PSS_STYLE :=2
CFLAGS   += -D_XBOX -D_XBOX360
CXXFLAGS += -D_XBOX -D_XBOX360
STATIC_LINKING=1
HAS_GCC := 0

# Windows MSVC 2017 all architectures
else ifneq (,$(findstring windows_msvc2017,$(platform)))
    CFLAGS += -D__WIN32__
    CXXFLAGS += -D__WIN32__

	PlatformSuffix = $(subst windows_msvc2017_,,$(platform))
	ifneq (,$(findstring desktop,$(PlatformSuffix)))
		WinPartition = desktop
        MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_DESKTOP_APP
		LDFLAGS += -MANIFEST -LTCG:incremental -NXCOMPAT -DYNAMICBASE -DEBUG -OPT:REF -INCREMENTAL:NO -SUBSYSTEM:WINDOWS -MANIFESTUAC:"level='asInvoker' uiAccess='false'" -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1
		LIBS += kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib
	else ifneq (,$(findstring uwp,$(PlatformSuffix)))
		WinPartition = uwp
		MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_APP -D_WINDLL -D_UNICODE -DUNICODE -D__WRL_NO_DEFAULT_LIB__ -ZW:nostdlib -EHsc
		LDFLAGS += -APPCONTAINER -NXCOMPAT -DYNAMICBASE -MANIFEST:NO -LTCG -OPT:REF -SUBSYSTEM:CONSOLE -MANIFESTUAC:NO -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1 -DEBUG:FULL -WINMD:NO
		LIBS += WindowsApp.lib
	endif

	# Specific to this core
	MSVC2017CompileFlags += -D__WIN32__

	CFLAGS += $(MSVC2017CompileFlags)
	CXXFLAGS += $(MSVC2017CompileFlags)

	TargetArchMoniker = $(subst $(WinPartition)_,,$(PlatformSuffix))

	CC  = cl.exe
	CXX = cl.exe

	reg_query = $(call filter_out2,$(subst $2,,$(shell reg query "$2" -v "$1" 2>nul)))
	fix_path = $(subst $(SPACE),\ ,$(subst \,/,$1))

	ProgramFiles86w := $(shell cmd /c "echo %PROGRAMFILES(x86)%")
	ProgramFiles86 := $(shell cygpath "$(ProgramFiles86w)")

	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir := $(WindowsSdkDir)

	WindowsSDKVersion ?= $(firstword $(foreach folder,$(subst $(subst \,/,$(WindowsSdkDir)Include/),,$(wildcard $(call fix_path,$(WindowsSdkDir)Include\*))),$(if $(wildcard $(call fix_path,$(WindowsSdkDir)Include/$(folder)/um/Windows.h)),$(folder),)))$(BACKSLASH)

=== debian/changelog ===
libretro-snes9x (1.59.2-1mx17+1) mx; urgency=medium

  * Repackaged for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 02 Mar 2019 07:32:44 -0800

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: libretro-snes9x
 Section: non-free/games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
 Build-Depends: debhelper (>= 9)
 Standards-Version: 3.9.8
-Homepage: http://www.snes9x.com
+Homepage: https://github.com/snes9xgit/snes9x
 
 Package: libretro-snes9x
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Makefile uses already -O3
export DEB_CXXFLAGS_MAINT_STRIP = -O2
export DEB_CFLAGS_MAINT_STRIP = -O2
# Fix hardening-no-bindnow
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(ARCH),armhf)
	PLATFORM=platform="armv hardfloat"
endif

%:
	dh $@ --sourcedirectory=libretro --parallel

override_dh_auto_build:
	dh_auto_build -- $(PLATFORM)

override_dh_installchangelogs:
	dh_installchangelogs -k docs/changes.txt
	
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## libretro-snes9x 1.61%2Bdfsg

=== libretro/Makefile ===
--- 
+++ 
@@ -135,6 +135,35 @@
 	    LDFLAGS += -static-libgcc -static-libstdc++
 	  endif
 	endif
+ 
+ # (armv8 a35, hard point, neon based) ### 
+# Playstation Classic 
+else ifeq ($(platform), classic_armv8_a35)
+	TARGET := $(TARGET_NAME)_libretro.so
+	fpic := -fPIC
+	SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
+	CXXFLAGS += -Ofast \
+	-flto=4 -fwhole-program -fuse-linker-plugin \
+	-fdata-sections -ffunction-sections -Wl,--gc-sections \
+	-fno-stack-protector -fno-ident -fomit-frame-pointer \
+	-falign-functions=1 -falign-jumps=1 -falign-loops=1 \
+	-fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
+	-fmerge-all-constants -fno-math-errno \
+	-marm -mtune=cortex-a8 -mfpu=neon-fp-armv8 -mfloat-abi=hard
+	CFLAGS += $(CXXFLAGS)
+	HAVE_NEON = 1
+	ARCH = arm
+	BUILTIN_GPU = neon
+	USE_DYNAREC = 1
+	ifeq ($(shell echo `$(CC) -dumpversion` "< 4.9" | bc -l), 1)
+	  CFLAGS += -march=armv8-a
+	else
+	  CFLAGS += -march=armv8-a
+	  # If gcc is 5.0 or later
+	  ifeq ($(shell echo `$(CC) -dumpversion` ">= 5" | bc -l), 1)
+	    LDFLAGS += -static-libgcc -static-libstdc++
+	  endif
+	endif
 #######################################
    
 # iOS
@@ -169,6 +198,20 @@
       CXXFLAGS += -miphoneos-version-min=5.0
    endif
 
+#tvOS
+else ifeq ($(platform), tvos-arm64)
+   CFLAGS += $(LTO)
+   CXXFLAGS += $(LTO)
+   LDFLAGS += $(LTO)
+   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
+   fpic := -fPIC
+   SHARED := -dynamiclib
+   ifeq ($(IOSSDK),)
+      IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
+   endif
+   CXXFLAGS += -DIOS
+   CXXFLAGS += -DARM
+
 # Theos
 else ifeq ($(platform), theos_ios)
    CFLAGS += $(LTO)
@@ -273,22 +316,6 @@
 else ifeq ($(platform), emscripten)
    TARGET := $(TARGET_NAME)_libretro_$(platform).bc
    STATIC_LINKING = 1
-
-# Genode
-else ifeq ($(platform), genode)
-   TARGET  := $(TARGET_NAME)_libretro.lib.so
-   PKG_CONFIG := genode-lib genode-stdcxx
-   CXXFLAGS += -D__GENODE__
-   CXXFLAGS += $(shell pkg-config --cflags $(PKG_CONFIG))
-
-   LDFLAGS += -shared --version-script=link.T
-   LDFLAGS += $(shell pkg-config --libs $(PKG_CONFIG))
-
-   CC  = $(shell pkg-config genode-base --variable=cc)
-   CXX = $(shell pkg-config genode-base --variable=cxx)
-   LD  = $(shell pkg-config genode-base --variable=ld)
-   AR  = $(shell pkg-config genode-base --variable=ar) -rcs
-   LIBS =
 
 # Windows MSVC 2003 Xbox 1
 else ifeq ($(platform), xbox1_msvc2003)
@@ -360,10 +387,3 @@
 	ProgramFiles86w := $(shell cmd /c "echo %PROGRAMFILES(x86)%")
 	ProgramFiles86 := $(shell cygpath "$(ProgramFiles86w)")
 
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir := $(WindowsSdkDir)
-
-	WindowsSDKVersion ?= $(firstword $(foreach folder,$(subst $(subst \,/,$(WindowsSdkDir)Include/),,$(wildcard $(call fix_path,$(WindowsSdkDir)Include\*))),$(if $(wildcard $(call fix_path,$(WindowsSdkDir)Include/$(folder)/um/Windows.h)),$(folder),)))$(BACKSLASH)

## libretro-snes9x 1.61+dfsg

=== gtk/meson_options.txt ===
option('opengl',          type: 'boolean', value: true,  description: 'Build support for OpenGL')
option('slang',           type: 'boolean', value: true,  description: 'Build support for slang-type shaders')
option('xv',              type: 'boolean', value: true,  description: 'Build support for XV')
option('portaudio',       type: 'boolean', value: true,  description: 'Build PortAudio sound driver')
option('oss',             type: 'boolean', value: true,  description: 'Build OSS sound driver')
option('alsa',            type: 'boolean', value: true,  description: 'Build ALSA sound driver')
option('pulseaudio',      type: 'boolean', value: true,  description: 'Build PulseAudio sound driver')
option('debugger',        type: 'boolean', value: true,  description: 'Enable Snes9x Debugger')
option('hq2x',            type: 'boolean', value: true,  description: 'Enable the HQ2x filters')
option('xbrz',            type: 'boolean', value: true,  description: 'Enable the xBRZ filters')
option('zlib',            type: 'boolean', value: true,  description: 'Enable gzip compression')
option('system-zip',      type: 'boolean', value: true,  description: 'Build using system minizip library')
option('screenshot',      type: 'boolean', value: true,  description: 'Enable screenshots')
option('wayland',         type: 'boolean', value: true,  description: 'Build support for Wayland')
option('dangerous-hacks', type: 'boolean', value: false, description: 'Allow dangerous hacks to be enabled')
option('appdatadir',      type: 'string' , value: '',    description: 'Snes9x-only data directory (default: datadir/snes9x)')

=== debian/changelog ===
libretro-snes9x (1.61+dfsg-1) unstable; urgency=medium

  * New upstream release
    * Switch to snes9x.com upstream
    * Remove patches applied upstream
    * Update watch file
    * Update upstream metadata pointers
    * Update debian/copyright
  * Switch to debhelper-compat, level 13
    * Drop executable install file
  * Add Vcs-* fields pointing to Salsa
  * Remove Sérgio Benjamim from uploaders, since he seems to be no longer
    active, and add myself.
  * Add debian/gbp.conf pointing to main as the Debian branch
  * Bump Standards-Version to 4.6.2
  * Set Rules-Requires-Root to no
  * Mark package as XS-Autobuild: yes

 -- Jonathan McDowell <noodles@earth.li>  Sun, 15 Jan 2023 16:41:34 +0000

libretro-snes9x (1.53+git20160522-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with GCC 11, thanks to Adrian Bunk.  (Closes: #998228)
  * Add upstream metadata.
  * Add watch file.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 22 Nov 2022 15:17:39 +0100

=== debian/watch ===
version=4

opts=dversionmangle=s/\+dfsg// \
https://github.com/snes9xgit/snes9x/tags \
  (?:.*?/)?v?(\d[\d.]*(?:-.*)?)\.tar\.gz

## libretro-snes9x 1.63+dfsg

=== gtk/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(snes9x-gtk VERSION 1.63)

option(USE_SLANG "Build support for Vulkan output and .slangp shaders" ON)
option(USE_XV "Build support for XVideo output" ON)
option(USE_PORTAUDIO "Build PortAudio sound driver" ON)
option(USE_ALSA "Build ALSA sound driver" ON)
option(USE_PULSEAUDIO "Use PulseAudio" ON)
option(USE_OSS "Build support for OSS" ON)
option(DEBUGGER "Enable Snes9x Debugger" ON)
option(USE_HQ2X "Build the HQ2x family of filters" ON)
option(USE_XBRZ "Build the XBRZ family of filters" ON)
option(USE_SYSTEMZIP "Force use of system minizip" ON)
option(USE_WAYLAND "Build support for Wayland" ON)
option(DANGEROUS_HACKS "Allow dangerous hacks to be used" ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(GNUInstallDirs)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "One of: Debug Release RelWithDebInfo MinSizeRel" FORCE)
endif(NOT CMAKE_BUILD_TYPE)

string(APPEND DATADIR ${CMAKE_INSTALL_PREFIX} "/" ${CMAKE_INSTALL_DATAROOTDIR} "/snes9x")
string(APPEND LOCALEDIR ${CMAKE_INSTALL_PREFIX} "/" ${CMAKE_INSTALL_DATAROOTDIR} "/locale")
add_compile_definitions(HAVE_LIBPNG
                        ZLIB SNES9X_GTK
                        NETPLAY_SUPPORT
                        JMA_SUPPORT
                        UNZIP_SUPPORT
                        HAVE_MKSTEMP
                        HAVE_STRINGS_H
                        HAVE_STDINT_H
                        RIGHTSHIFT_IS_SAR
                        "GETTEXT_PACKAGE=\"${CMAKE_PROJECT_NAME}\""
                        DATADIR=\"${DATADIR}\"
                        SNES9XLOCALEDIR=\"${LOCALEDIR}\")
set(INCLUDES ../apu/bapu ../ src)
set(SOURCES)
set(ARGS -Wall -Wno-unused-parameter -Wno-unused-variable)
set(LIBS)
set(DEFINES)

include(CheckIncludeFile)

include(FindGettext)

# Add any new language to this foreach loop
foreach(lang de es fr_FR ja pl pt_BR ru sr@latin uk zh_CN)
    GETTEXT_PROCESS_PO_FILES(${lang} ALL PO_FILES po/${lang}.po)
    install(FILES ${CMAKE_BINARY_DIR}/${lang}.gmo
            DESTINATION ${LOCALEDIR}/${lang}/LC_MESSAGES
            RENAME ${CMAKE_PROJECT_NAME}.mo
            COMPONENT translations)
endforeach()

find_package(PkgConfig REQUIRED)
pkg_check_modules(SDL2 REQUIRED sdl2)
pkg_check_modules(GTK REQUIRED gtkmm-3.0 gthread-2.0 libpng)
pkg_check_modules(XRANDR REQUIRED xrandr)

find_library(X11 X11 REQUIRED)
find_library(XEXT Xext REQUIRED)
list(APPEND ARGS ${SDL2_CFLAGS} ${GTK_CFLAGS} ${XRANDR_CFLAGS})
list(APPEND LIBS ${X11} ${XEXT} ${CMAKE_DL_LIBS} ${SDL2_LIBRARIES} ${GTK_LIBRARIES} ${XRANDR_LIBRARIES})

list(APPEND SOURCES src/gtk_display_driver_opengl.cpp
                    ../common/video/glx_context.cpp
                    ../shaders/glsl.cpp
                    ../shaders/shader_helpers.cpp
                    ../vulkan/slang_helpers.cpp
                    ../vulkan/slang_helpers.hpp
                    ../vulkan/slang_preset_ini.cpp
                    ../vulkan/slang_preset_ini.hpp
                    ../external/glad/src/glx.c
                    ../external/glad/src/egl.c
                    ../external/glad/src/gl.c
                    src/gtk_shader_parameters.cpp
                    ../vulkan/std_chrono_throttle.cpp
                    ../vulkan/std_chrono_throttle.hpp)
list(APPEND INCLUDES ../external/glad/include)

if(USE_SLANG)
    list(APPEND SOURCES ../shaders/slang.cpp)
    list(APPEND INCLUDES ../external/glslang)

    set(SPIRV_CROSS_EXCEPTIONS_TO_ASSERTIONS CACHE BOOL ON)
    set(BUILD_TESTING CACHE BOOL OFF)
    add_subdirectory("../external/glslang" "glslang" EXCLUDE_FROM_ALL)
    add_subdirectory("../external/SPIRV-Cross" "SPIRV-Cross" EXCLUDE_FROM_ALL)
    list(APPEND LIBS glslang
                     OGLCompiler
                     HLSL
                     OSDependent
                     SPIRV
                     glslang-default-resource-limits)
    list(APPEND LIBS spirv-cross-core
                     spirv-cross-glsl
                     spirv-cross-reflect
                     spirv-cross-cpp)
    list(APPEND DEFINES "USE_SLANG")
    list(APPEND INCLUDES "../external/glslang")

    list(APPEND DEFINES "VK_USE_PLATFORM_XLIB_KHR"
                        "VK_USE_PLATFORM_WAYLAND_KHR"
                        "VULKAN_HPP_DISPATCH_LOADER_DYNAMIC=1"
                        "VULKAN_HPP_NO_NODISCARD_WARNINGS=1"
                        "VULKAN_HPP_NO_EXCEPTIONS=1"
                        "VMA_DYNAMIC_VULKAN_FUNCTIONS=1"
                        "VMA_STATIC_VULKAN_FUNCTIONS=0"
                        "IMGUI_IMPL_VULKAN_NO_PROTOTYPES")
    list(APPEND INCLUDES ../external/vulkan-headers/include)
    list(APPEND INCLUDES ../external/VulkanMemoryAllocator-Hpp/include)
    list(APPEND INCLUDES ../external/stb)
    list(APPEND SOURCES ../external/stb/stb_image_implementation.cpp)
    list(APPEND SOURCES ../vulkan/slang_shader.cpp
                        ../vulkan/slang_shader.hpp
                        ../vulkan/slang_preset.cpp
                        ../vulkan/slang_preset.hpp
                        ../vulkan/vulkan_hpp_storage.cpp
                        ../vulkan/vk_mem_alloc_implementation.cpp
                        ../vulkan/vulkan_context.cpp
                        ../vulkan/vulkan_context.hpp
                        ../vulkan/vulkan_texture.cpp
                        ../vulkan/vulkan_texture.hpp
                        ../vulkan/vulkan_swapchain.cpp
                        ../vulkan/vulkan_swapchain.hpp
                        ../vulkan/vulkan_slang_pipeline.cpp
                        ../vulkan/vulkan_slang_pipeline.hpp
                        ../vulkan/vulkan_pipeline_image.cpp
                        ../vulkan/vulkan_pipeline_image.hpp
                        ../vulkan/vulkan_shader_chain.cpp
                        ../vulkan/vulkan_shader_chain.hpp
                        ../vulkan/vulkan_simple_output.hpp
                        ../vulkan/vulkan_simple_output.cpp
                        src/gtk_display_driver_vulkan.cpp
                        src/gtk_display_driver_vulkan.h
                        ../external/imgui/imgui_impl_vulkan.cpp)
endif()


list(APPEND SOURCES ../external/imgui/imgui.cpp
../external/imgui/imgui_demo.cpp
../external/imgui/imgui_draw.cpp
../external/imgui/imgui_impl_opengl3.cpp
../external/imgui/imgui_tables.cpp
../external/imgui/imgui_widgets.cpp
../external/imgui/snes9x_imgui.cpp)
list(APPEND INCLUDES ../external/imgui)

if(USE_WAYLAND)
    pkg_check_modules(WAYLAND REQUIRED wayland-client wayland-egl)
    list(APPEND DEFINES "USE_WAYLAND")
    list(APPEND SOURCES ../common/video/wayland_egl_context.cpp
                        ../common/video/wayland_egl_context.hpp
                        ../common/video/wayland_surface.cpp
                        ../common/video/wayland_surface.hpp
                        ../common/video/wayland-idle-inhibit-unstable-v1.c
                        ../common/video/viewporter-client-protocol.c
                        ../common/video/fractional-scale-v1.c)
    list(APPEND ARGS ${WAYLAND_CFLAGS})
    list(APPEND LIBS ${WAYLAND_LIBRARIES})
endif()

if(USE_XV)
    pkg_check_modules(XV REQUIRED xv)
    list(APPEND DEFINES "USE_XV")
    list(APPEND SOURCES src/gtk_display_driver_xv.cpp
                        src/gtk_display_driver_xv.h)
    list(APPEND ARGS ${XV_CFLAGS})
    list(APPEND LIBS ${XV_LIBRARIES})
endif()

if(USE_PULSEAUDIO)
    pkg_check_modules(PULSEAUDIO REQUIRED libpulse)
    list(APPEND DEFINES "USE_PULSEAUDIO")
    list(APPEND SOURCES ../common/audio/s9x_sound_driver_pulse.cpp)
    list(APPEND ARGS ${PULSEAUDIO_CFLAGS})
    list(APPEND LIBS ${PULSEAUDIO_LIBRARIES})
endif()

if(USE_PORTAUDIO)
    pkg_check_modules(PORTAUDIO REQUIRED portaudio-2.0)
    list(APPEND DEFINES "USE_PORTAUDIO")
    list(APPEND SOURCES ../common/audio/s9x_sound_driver_portaudio.cpp)
    list(APPEND ARGS ${PORTAUDIO_CFLAGS})
    list(APPEND LIBS ${PORTAUDIO_LIBRARIES})
endif()

if(USE_ALSA)
    pkg_check_modules(ALSA REQUIRED alsa)
    list(APPEND DEFINES "USE_ALSA")
    list(APPEND SOURCES ../common/audio/s9x_sound_driver_alsa.cpp)
    list(APPEND ARGS ${ALSA_CFLAGS})
    list(APPEND LIBS ${ALSA_LIBRARIES})
endif()

if(USE_OSS)
    CHECK_INCLUDE_FILE("sys/soundcard.h" OSS)
    if(OSS)
        list(APPEND SOURCES ../common/audio/s9x_sound_driver_oss.cpp)
        list(APPEND DEFINES "USE_OSS")
    endif()
endif()

pkg_check_modules(LIBPNG REQUIRED "libpng")
list(APPEND ARGS ${LIBPNG_CFLAGS})
list(APPEND LIBS ${LIBPNG_LIBRARIES})

pkg_check_modules(ZLIB REQUIRED "zlib")
list(APPEND ARGS ${ZLIB_CFLAGS})
list(APPEND LIBS ${ZLIB_LIBRARIES})

pkg_check_modules(MINIZIP "minizip")
if(USE_SYSTEMZIP AND MINIZIP_FOUND)
    list(APPEND DEFINES "SYSTEM_ZIP")
    list(APPEND ARGS ${MINIZIP_CFLAGS})
    list(APPEND LIBS ${MINIZIP_LIBRARIES})
else()
    list(APPEND INCLUDES ../unzip)
    list(APPEND SOURCES ../unzip/unzip.c ../unzip/ioapi.c ../unzip/zip.c)
endif()

if(USE_HQ2X)
    list(APPEND DEFINES "USE_HQ2X")
    list(APPEND SOURCES ../filter/hq2x.cpp)
endif()

if(USE_XBRZ)
    list(APPEND DEFINES "USE_XBRZ")
    list(APPEND SOURCES ../filter/xbrz.cpp ../filter/xbrz.h src/filter_xbrz.cpp)
endif()

if(DANGEROUS_HACKS)
    list(APPEND DEFINES ALLOW_CPU_OVERCLOCK)
    message("Dangerous hacks are enabled. Use at your own risk.")
endif()

list(APPEND SOURCES
    ../common/audio/s9x_sound_driver.hpp
    ../filter/2xsai.cpp
    ../filter/2xsai.h
    ../filter/epx.cpp
    ../filter/epx.h
    src/filter_epx_unsafe.h
    src/filter_epx_unsafe.cpp
    src/gtk_binding.cpp
    src/gtk_binding.h
    src/gtk_cheat.cpp
    src/gtk_cheat.h
    src/gtk_config.cpp
    src/gtk_config.h
    src/gtk_control.cpp
    src/gtk_control.h
    src/gtk_display.cpp
    src/gtk_display_driver_gtk.cpp
    src/gtk_display_driver_gtk.h
    src/gtk_display_driver.h
    src/gtk_display.h
    src/threadpool.cpp
    src/threadpool.h
    src/gtk_file.cpp
    src/gtk_file.h
    src/gtk_builder_window.cpp
    src/gtk_builder_window.h
    src/gtk_preferences.cpp
    src/gtk_preferences.h
    src/gtk_s9xcore.h
    src/gtk_s9x.cpp
    src/gtk_s9x.h
    src/gtk_s9xwindow.cpp
    src/gtk_s9xwindow.h
    src/gtk_sound.cpp
    src/gtk_sound.h
    src/gtk_splash.cpp
    ../filter/snes_ntsc_config.h
    ../filter/snes_ntsc.h
    ../filter/snes_ntsc_impl.h
    ../filter/snes_ntsc.c
    src/gtk_compat.h
    ../common/audio/s9x_sound_driver_sdl.hpp
    ../common/audio/s9x_sound_driver_sdl.cpp
    ../fxinst.cpp
    ../fxemu.cpp
    ../fxdbg.cpp
    ../c4.cpp
    ../c4emu.cpp
    ../apu/apu.cpp
    ../apu/bapu/dsp/sdsp.cpp
    ../apu/bapu/smp/smp.cpp
    ../apu/bapu/smp/smp_state.cpp
    ../msu1.cpp
    ../msu1.h
    ../dsp.cpp
    ../dsp1.cpp
    ../dsp2.cpp
    ../dsp3.cpp
    ../dsp4.cpp
    ../spc7110.cpp
    ../obc1.cpp
    ../seta.cpp
    ../seta010.cpp
    ../seta011.cpp
    ../seta018.cpp
    ../controls.cpp
    ../crosshairs.cpp
    ../cpu.cpp
    ../sa1.cpp
    ../debug.cpp
    ../sdd1.cpp
    ../tile.cpp
    ../tileimpl-n1x1.cpp
    ../tileimpl-n2x1.cpp
    ../tileimpl-h2x1.cpp
    ../srtc.cpp
    ../gfx.cpp
    ../memmap.cpp
    ../clip.cpp
    ../ppu.cpp
    ../dma.cpp
    ../snes9x.cpp
    ../globals.cpp
    ../stream.cpp
    ../conffile.cpp
    ../bsx.cpp
    ../snapshot.cpp
    ../screenshot.cpp
    ../movie.cpp
    ../statemanager.cpp
    ../sha256.cpp
    ../bml.cpp
    ../cpuops.cpp
    ../cpuexec.cpp
    ../sa1cpu.cpp
    ../cheats.cpp
    ../cheats2.cpp
    ../sdd1emu.cpp
    ../netplay.cpp
    ../server.cpp
    ../loadzip.cpp
    ../fscompat.cpp
    src/gtk_netplay_dialog.cpp
    src/gtk_netplay_dialog.h
    src/gtk_netplay.cpp
    src/gtk_netplay.h
    src/background_particles.cpp
    src/background_particles.h)

list(APPEND SOURCES ../external/fmt/src/format.cc)
list(APPEND INCLUDES ../external/fmt/include)

set(LIBJMA_SOURCES
    ../jma/s9x-jma.cpp
    ../jma/7zlzma.cpp
    ../jma/crc32.cpp
    ../jma/iiostrm.cpp

=== libretro/Makefile ===
--- 
+++ 
@@ -74,7 +74,7 @@
 # OS X
 else ifeq ($(platform), osx)
    CFLAGS += $(LTO)
-   CXXFLAGS += $(LTO)
+   CXXFLAGS += -std=c++14 $(LTO)
    LDFLAGS += $(LTO)
    TARGET := $(TARGET_NAME)_libretro.dylib
    fpic := -fPIC

=== debian/changelog ===
libretro-snes9x (1.63+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan McDowell <noodles@earth.li>  Sat, 25 Jan 2025 17:47:56 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: libretro-snes9x
 Section: non-free/games
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.8
-Homepage: https://github.com/snes9xgit/snes9x
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders: Jonathan McDowell <noodles@earth.li>
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.6.2
+Homepage: http://www.snes9x.com
+Vcs-Browser: https://salsa.debian.org/games-team/libretro/libretro-snes9x
+Vcs-Git: https://salsa.debian.org/games-team/libretro/libretro-snes9x.git
+Rules-Requires-Root: no
+XS-Autobuild: yes
 
 Package: libretro-snes9x
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Makefile uses already -O3
export DEB_CXXFLAGS_MAINT_STRIP = -O2
export DEB_CFLAGS_MAINT_STRIP = -O2
# Fix hardening-no-bindnow
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

export DEB_CXXFLAGS_MAINT_APPEND += -std=gnu++14

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(ARCH),armhf)
	PLATFORM=platform="armv hardfloat"
endif

%:
	dh $@ --sourcedirectory=libretro

override_dh_auto_build:
	dh_auto_build -- $(PLATFORM)

override_dh_installchangelogs:
	dh_installchangelogs -k docs/changes.txt
